/*=========================================================================

 Program:   vv
 Module:    $RCSfile: vvCommon.cxx,v $
 Language:  C++
 Date:      $Date: 2008/04/10 06:59:36 $
 Version:   $Revision: 1.2 $
 Author :   Pierre Seroul (pierre.seroul@gmail.com)

Copyright (C) 2008
Léon Bérard cancer center http://oncora1.lyon.fnclcc.fr
CREATIS-LRMN http://www.creatis.insa-lyon.fr

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

=========================================================================*/
#ifndef VVCOMMON_CXX
#define VVCOMMON_CXX

#include "vvCommon.h"

//====================================================================
// skip line which begin with a sharp '#'
void vv::skipComment(std::istream & is) 
{
  char c;
  char line[1024];
  if (is.eof()) return;
  is >> c ; 
  while (is && (c == '#')) {
	is.getline (line, 1024); 
	is >> c;
	if (is.eof()) return;
  }
  is.unget();
} ////
//====================================================================
  
//====================================================================
// Return filename extension
std::string vv::GetExtension(const std::string& filename) 
{
  // This assumes that the final '.' in a file name is the delimiter
  // for the file's extension type
  const std::string::size_type it = filename.find_last_of( "." );	
  // This determines the file's type by creating a new string
  // who's value is the extension of the input filename
  // eg. "myimage.gif" has an extension of "gif"
  std::string fileExt( filename, it+1, filename.length() );	
  return( fileExt );
} ////
//====================================================================

#endif /* end #define VVCOMMON_CXX */

