/*=========================================================================

 Program:   vv
 Module:    $RCSfile: vvCommon.h,v $
 Language:  C++
 Date:      $Date: 2008/04/10 06:59:36 $
 Version:   $Revision: 1.2 $
 Author :   Pierre Seroul (pierre.seroul@gmail.com)

Copyright (C) 2008
Léon Bérard cancer center http://oncora1.lyon.fnclcc.fr
CREATIS-LRMN http://www.creatis.insa-lyon.fr

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

=========================================================================*/
#ifndef VVCOMMON_H
#define VVCOMMON_H

// std include
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>

#include "vvVoxImageIOFactory.h"
#include <itkImageRegionConstIterator.h>

//====================================================================
namespace vv {
  
  typedef unsigned char uchar;
  typedef unsigned short ushort;
  typedef unsigned int uint;

  //====================================================================
  // display 
#define DD(a) std::cout << #a " = [ " << a << " ]" << std::endl;
  
  //====================================================================
  // GGO default
#define GGO(args_info)							\
  gengetopt_args_info args_info;					\
    cmdline_parser2(argc, argv, &args_info, 1, 1, 0);			\
    if (args_info.config_given)						\
      cmdline_parser_configfile (args_info.config_arg, &args_info, 0, 0, 1); \
    else cmdline_parser(argc, argv, &args_info);
  
  //====================================================================
  // skip line with #
  void skipComment(std::istream & is);

  //====================================================================
  // Return filename extension
  std::string GetExtension(const std::string& filename);
  
  //====================================================================
  // Convert float, double ... to string
  template<class T> std::string toString(const T & t);
  template<class T> std::string toString(const T & t, int precision, int width);
  template<class T> std::string toStringVector(const T * t, const int n);
  template<class T> std::string toStringVector(const T & t, const int n);

  //====================================================================
  // Return the name of a type as a string
  template<class TPixel>
  std::string GetTypeAsString();

  //====================================================================
  template<class ImageType>
  int ComputeHowManyDifferentIntensity(const typename ImageType::Pointer & image, 
				       std::vector<typename ImageType::PixelType> & l);

#include "vvCommon.txx"

} // end namespace

#endif /* end #define VVCOMMON_H */

