/*=========================================================================

 Program:   vv
 Module:    $RCSfile: vvConvertITKImageToVTKDataFilter.cxx,v $
 Language:  C++
 Date:      $Date: 2008/06/16 14:05:47 $
 Version:   $Revision: 1.3 $
 Author :   Pierre Seroul (pierre.seroul@gmail.com)

Copyright (C) 2008
Léon Bérard cancer center http://oncora1.lyon.fnclcc.fr
CREATIS-LRMN http://www.creatis.insa-lyon.fr

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

=========================================================================*/
#ifndef vvConvertITKImageToVTKDataFilter_CXX
#define vvConvertITKImageToVTKDataFilter_CXX

#include "vvConvertITKImageToVTKDataFilter.h"

#include <string.h>
//====================================================================
vvConvertITKImageToVTKDataFilter::vvConvertITKImageToVTKDataFilter() {
  mImage = new(vvImage);
  mInputFilename.resize(0);// = "defaultInput.mhd";
  mLastError = "";
  mUseAnObserver = false;
  mType = -1;
}
//====================================================================

//====================================================================
vvConvertITKImageToVTKDataFilter::~vvConvertITKImageToVTKDataFilter() {
  delete mImage;
}
//====================================================================

//====================================================================
void vvConvertITKImageToVTKDataFilter::Update(int dim,std::string inputPixelType, int type) { 
  //CALL_FOR_ALL_DIMS(dim,UpdateWithDim,inputPixelType);
  mType = type;
  if(dim == 2)
    UpdateWithDim<2>(inputPixelType);
  else if(dim == 3)
    UpdateWithDim<3>(inputPixelType);
  else if(dim == 4)
    UpdateWithDim<4>(inputPixelType);
  else
    std::cerr << "dimension unknown in Update ! " << std::endl;
}
//====================================================================

//====================================================================
/*void vvConvertITKImageToVTKDataFilter::Extract(int dim, std::string inputPixelType, int slice) { 
  CALL_FOR_ALL_DIMS(dim, ExtractWithDim, inputPixelType, slice);
}*/
//====================================================================

//====================================================================
void vvConvertITKImageToVTKDataFilter::SetInputFileName(const std::vector<std::string> & filename) {
  mInputFilename = filename;
}
//====================================================================

#endif

