/*=========================================================================

 Program:   vv
 Module:    $RCSfile: vvConvertITKVectorToVTKDataFilter.cxx,v $
 Language:  C++
 Date:      $Date: 2008/06/25 07:53:19 $
 Version:   $Revision: 1.3 $
 Author :   Pierre Seroul (pierre.seroul@gmail.com)

Copyright (C) 2008
Léon Bérard cancer center http://oncora1.lyon.fnclcc.fr
CREATIS-LRMN http://www.creatis.insa-lyon.fr

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

=========================================================================*/
#ifndef vvConvertITKVectorToVTKDataFilter_CXX
#define vvConvertITKVectorToVTKDataFilter_CXX

#include "vvConvertITKVectorToVTKDataFilter.h"

#include <string.h>
//====================================================================
vvConvertITKVectorToVTKDataFilter::vvConvertITKVectorToVTKDataFilter() {
	std::string test;
  mImage = new(vvVF);
  mInputFilename = "";// = "defaultInput.mhd";
  mLastError = "";
  mUseAnObserver = false;
}
//====================================================================

//====================================================================
vvConvertITKVectorToVTKDataFilter::~vvConvertITKVectorToVTKDataFilter() {
  delete mImage;
}
//====================================================================

//====================================================================
void vvConvertITKVectorToVTKDataFilter::Update(unsigned int dim,std::string inputPixelType) { 
  //std::cout << "Update(" << dim << "," << inputPixelType << ")" << std::endl;
  if(dim == 2)
    UpdateWithDim<2>(inputPixelType);
  else if(dim == 3)
    UpdateWithDim<3>(inputPixelType);
  else if(dim == 4)
    UpdateWithDim<4>(inputPixelType);
  else
    std::cerr << "dim not know in Update ! " << std::endl;
}
//====================================================================

//====================================================================
void vvConvertITKVectorToVTKDataFilter::SetInputFileName(const std::string & filename) {
  mInputFilename = filename;
}
//====================================================================

#endif

