/*=========================================================================

 Program:   vv
 Module:    $RCSfile: vvImage.h,v $
 Language:  C++
 Date:      $Date: 2008/06/23 14:35:14 $
 Version:   $Revision: 1.3 $
 Author :   Pierre Seroul (pierre.seroul@gmail.com)

Copyright (C) 2008
Léon Bérard cancer center http://oncora1.lyon.fnclcc.fr
CREATIS-LRMN http://www.creatis.insa-lyon.fr

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

=========================================================================*/
#ifndef vvImage_h
#define vvImage_h

#include <iostream>
#include <vector>

class vtkImageData;

class vvImage
{
public :
  vvImage();
  ~vvImage();

  void Init();
  void SetImage(std::vector<vtkImageData*> images);
  void AddImage(vtkImageData* image);

  int GetNumberOfDimensions();
  unsigned long GetActualMemorySize();
  std::vector<double> GetSpacing();
  std::vector<double> GetOrigin();
  std::vector<int> GetSize();
  std::string GetScalarTypeAsString();
  int GetNumberOfScalarComponents();
  int GetScalarSize();

  std::vector<vtkImageData*> GetImage(){ return mVtkImages; }

private:
  std::vector<vtkImageData*> mVtkImages;

};

#endif
