/*=========================================================================

 Program:   vv
 Module:    $RCSfile: vvSlicersManagerCommand.h,v $
 Language:  C++
 Date:      $Date: 2008/07/09 14:18:40 $
 Version:   $Revision: 1.4 $
 Author :   Pierre Seroul (pierre.seroul@gmail.com)

Copyright (C) 2008
Léon Bérard cancer center http://oncora1.lyon.fnclcc.fr
CREATIS-LRMN http://www.creatis.insa-lyon.fr

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

=========================================================================*/
#ifndef __vvSlicersManagerCommand_h
#define __vvSlicersManagerCommand_h

#include "vtkCommand.h"
#include "vvSlicersManager.h"
#include "vtkRenderWindow.h"
#include "vtkRenderer.h"
#include "vtkImageData.h"
#include "vtkImageActor.h"
#include "vvInteractorStyleNavigator.h"
#include "vtkRenderWindowInteractor.h"
#include "vtkInteractorStyleImage.h"
#include "vtkPropPicker.h"

#include <iostream>
#include <string>
#include <sstream>

class vvSlicersManagerCallback : public vtkCommand
{
public:
  static vvSlicersManagerCallback *New() { return new vvSlicersManagerCallback; }
  
  void Execute(vtkObject *caller, 
               unsigned long event, 
               void *vtkNotUsed(callData));

  vvSlicersManager *SM;
  void Dolly(double factor, vtkRenderWindowInteractor *interactor);
  void FlyToPosition(vtkRenderWindowInteractor *interactor, vvSlicer* slicer);

protected :
  vvSlicersManagerCallback();
  ~vvSlicersManagerCallback(){}

private:

  int IsOneOfTheSlicer(int x, int y, vvInteractorStyleNavigator* isi, vvSlicersManager *IV);
  int IsWindowNumber(int x, int y, vvInteractorStyleNavigator* isi, vvSlicersManager *IV);
  int IsVisibleInWindow(int x, int y, vvInteractorStyleNavigator* isi, vvSlicersManager *IV);

  double InitialWindow;
  double InitialLevel;
  int mStartSlicer;
  int mCurrentSlicer;
  bool newLandmark;
};

#endif
